// Modified
/* 

   CS 202, Fall 2007
   Homework#9, Problem 1

   Author: Harish Kumar (Modifications done to fig08_15.cpp) 

*/

// Fig. 8.15: fig08_15.cpp
// This program puts values into an array, sorts the values into
// ascending order and prints the resulting array.
#include <iostream> 
using std::cout;
using std::endl; 

#include <iomanip>
using std::setw;

// Definition of function template to sort an array
template< typename T>
void selectionSort( T * const array, const int size )
{
   int smallest; // index of smallest element

   // loop over size - 1 elements
   for ( int i = 0; i < size - 1; i++ )
   {
      smallest = i; // first index of remaining array

      // loop to find index of smallest element
      for ( int index = i + 1; index < size; index++ )

         if ( array[ index ] < array[ smallest ] )
            smallest = index;

      swap( &array[ i ], &array[ smallest ] );
   } // end if
} // end function template selectionSort


// swap values at memory locations to which
// element1Ptr and element2Ptr point
template< typename T>
void swap( T * const element1Ptr, T * const element2Ptr )
{
   T hold = *element1Ptr;
   *element1Ptr = *element2Ptr;
   *element2Ptr = hold;
} // end function template swap

int main()
{
   const int arraySize = 10;
   int a[ arraySize ] = { 2, 6, 4, 8, 10, 12, 89, 68, 45, 37 };
   float sort[arraySize] =  { 1.22, 4.56, 3.42, 0.32, 45.0, 12.332, 2.67, 4.4, 
22.2, 10.34 }; // float array sort
   float output[arraySize] = { 3.23, 1.23, 45.34, 3.32, 233.23, 43.4, 23.23, 
324.23, 23.1, 43.23 }; // float array output

   // displaying original integer array 'a' and sorted integer array 'a'
   cout << "Array 'a' Data items in original order\n";
   for ( int i = 0; i < arraySize; i++ )
      cout << setw( 4 ) << a[ i ];
   selectionSort( a, arraySize ); // sort the array
   cout << "\n Array 'a' Data items in ascending order\n";
   for ( int j = 0; j < arraySize; j++ )
      cout << setw( 4 ) << a[ j ];
   cout << endl << endl;

   // displaying original float array 'sort' and sorted float array 'sort'
   cout << "Array 'sort' Data items in original order\n";
   for ( int i = 0; i < arraySize; i++ )
      cout << setw( 7 ) << sort[ i ];
   selectionSort( sort, arraySize ); // sort the array
   cout << "\n Array 'sort' Data items in ascending order\n";
   for ( int j = 0; j < arraySize; j++ )
      cout << setw( 7 ) << sort[ j ];
   cout << endl << endl;

   // displaying original float array 'output' and sorted float array 'output'
   cout << "Array 'output' Data items in original order\n";
   for ( int i = 0; i < arraySize; i++ )
      cout << setw( 7 ) << output[ i ];
   selectionSort( output, arraySize ); // sort the array
   cout << "\n Array 'output' Data items in ascending order\n";
   for ( int j = 0; j < arraySize; j++ )
      cout << setw( 7 ) << output[ j ];
   cout << endl << endl;
   return 0; // indicates successful termination
} // end main

/**************************************************************************
 * (C) Copyright 1992-2005 by Deitel & Associates, Inc. and               *
 * Pearson Education, Inc. All Rights Reserved.                           *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 **************************************************************************/
/* Program Output:

Array 'a' Data items in original order

   2   6   4   8  10  12  89  68  45  37

 Array 'a' Data items in ascending order

   2   4   6   8  10  12  37  45  68  89



Array 'sort' Data items in original order

   1.22   4.56   3.42   0.32     45 12.332   2.67    4.4   22.2  10.34

 Array 'sort' Data items in ascending order

   0.32   1.22   2.67   3.42    4.4   4.56  10.34 12.332   22.2     45



Array 'output' Data items in original order

   3.23   1.23  45.34   3.32 233.23   43.4  23.23 324.23   23.1  43.23

 Array 'output' Data items in ascending order

   1.23   3.23   3.32   23.1  23.23  43.23   43.4  45.34 233.23 324.23



*/


